ir_tarval *new_tarval_from_str(const char *str, size_t len, ir_mode *mode);
ir_tarval *new_integer_tarval_from_str(const char *str, size_t len,
                                       int negative, unsigned char base,
                                       ir_mode *mode);
ir_tarval *new_tarval_from_long(long l, ir_mode *mode);
ir_tarval *new_tarval_from_bytes(unsigned char const *buf, ir_mode *mode);
ir_tarval *new_tarval_nan(ir_mode *mode, int signaling,
                          ir_tarval const *payload);
void tarval_to_bytes(unsigned char *buffer, ir_tarval const *tv);
long get_tarval_long(ir_tarval const *tv);
int tarval_is_long(ir_tarval const *tv);
ir_tarval *new_tarval_from_double(double d, ir_mode *mode);
ir_tarval *new_tarval_from_long_double(long double d, ir_mode *mode);
double get_tarval_double(ir_tarval const *tv);
long double get_tarval_long_double(ir_tarval const *tv);
int tarval_is_double(ir_tarval const *tv);
ir_mode *get_tarval_mode(ir_tarval const *tv);
int tarval_is_negative(ir_tarval const *tv);
int tarval_is_null(ir_tarval const *tv);
int tarval_is_one(ir_tarval const *tv);
int tarval_is_all_one(ir_tarval const *tv);
int tarval_is_constant(ir_tarval const *tv);
ir_tarval *get_tarval_bad(void);
ir_tarval *get_tarval_unknown(void);
ir_tarval *get_tarval_b_false(void);
ir_tarval *get_tarval_b_true(void);
void tarval_set_wrap_on_overflow(int wrap_on_overflow);
int tarval_get_wrap_on_overflow(void);
ir_relation tarval_cmp(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_convert_to(ir_tarval const *src, ir_mode *mode);
ir_tarval *tarval_bitcast(ir_tarval const *src, ir_mode *mode);
ir_tarval *tarval_not(ir_tarval const *a);
ir_tarval *tarval_neg(ir_tarval const *a);
ir_tarval *tarval_add(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_sub(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_mul(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_div(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_mod(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_divmod(ir_tarval const *a, ir_tarval const *b,
                                  ir_tarval **mod_res);
ir_tarval *tarval_abs(ir_tarval const *a);
ir_tarval *tarval_and(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_andnot(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_or(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_ornot(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_eor(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_shl(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_shl_unsigned(ir_tarval const *a, unsigned b);
ir_tarval *tarval_shr(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_shr_unsigned(ir_tarval const *a, unsigned b);
ir_tarval *tarval_shrs(ir_tarval const *a, ir_tarval const *b);
ir_tarval *tarval_shrs_unsigned(ir_tarval const *a, unsigned b);
unsigned char get_tarval_sub_bits(ir_tarval const *tv, unsigned byte_ofs);
int get_tarval_popcount(ir_tarval const *tv);
int get_tarval_lowest_bit(ir_tarval const *tv);
int get_tarval_highest_bit(ir_tarval const *tv);
int tarval_zero_mantissa(ir_tarval const *tv);
int tarval_get_exponent(ir_tarval const *tv);
int tarval_ieee754_can_conv_lossless(ir_tarval const *tv, const ir_mode *mode);
unsigned tarval_ieee754_get_exact(void);
int tarval_is_nan(ir_tarval const *tv);
int tarval_is_quiet_nan(ir_tarval const *tv);
int tarval_is_signaling_nan(ir_tarval const *tv);
int tarval_is_finite(ir_tarval const *tv);
ir_tarval *computed_value(const ir_node *n);
