void add_class_supertype(ir_type *clss, ir_type *supertype);
ir_type *get_array_element_type(const ir_type *array);
unsigned get_array_size(const ir_type *array);
ir_entity *get_class_member(const ir_type *clss, size_t pos);
size_t get_class_n_members(const ir_type *clss);
size_t get_class_n_subtypes(const ir_type *clss);
size_t get_class_n_supertypes(const ir_type *clss);
ir_type *get_class_subtype(const ir_type *clss, size_t pos);
ir_type *get_class_supertype(const ir_type *clss, size_t pos);
const char *get_compound_name(const ir_type *clss);
ir_entity *get_compound_member(const ir_type *tp, size_t pos);
ir_type *get_glob_type(void);
mtp_additional_properties get_method_additional_properties(const ir_type *method);
unsigned get_method_calling_convention(const ir_type *method);
size_t get_method_n_params(const ir_type *method);
unsigned get_method_n_regparams(ir_type *method);
size_t get_method_n_ress(const ir_type *method);
ir_type *get_method_param_type(const ir_type *method, size_t pos);
ir_type *get_method_res_type(const ir_type *method, size_t pos);
ir_mode *get_modeBs(void);
ir_mode *get_modeBu(void);
ir_mode *get_modeD(void);
ir_mode *get_modeF(void);
ir_mode *get_modeHs(void);
ir_mode *get_modeHu(void);
ir_mode *get_modeIs(void);
ir_mode *get_modeIu(void);
ir_mode *get_modeLs(void);
ir_mode *get_modeLu(void);
ir_mode *get_modeM(void);
ir_mode *get_modeP(void);
ir_mode *get_modeT(void);
ir_mode *get_modeX(void);
unsigned get_mode_size_bytes(const ir_mode *mode);
const char *get_mode_name(const ir_mode *mode);
ir_type *get_pointer_points_to_type(const ir_type *pointer);
ir_entity *get_struct_member(const ir_type *strct, size_t pos);
size_t get_struct_n_members(const ir_type *strct);
ir_mode *get_type_mode(const ir_type *tp);
ir_entity *get_union_member(const ir_type *uni, size_t pos);
size_t get_union_n_members(const ir_type *uni);
ir_type *get_unknown_type(void);
int is_method_variadic(ir_type const *method);
int is_SubClass_of(const ir_type *low, const ir_type *high);
int is_SubClass_ptr_of(ir_type *low, ir_type *high);
int is_class_trans_subtype(const ir_type *tp, const ir_type *subtp);
int is_Array_type(const ir_type *array);
int is_Class_type(const ir_type *clss);
int is_Method_type(const ir_type *method);
int is_Pointer_type(const ir_type *pointer);
int is_Primitive_type(const ir_type *primitive);
int is_Struct_type(const ir_type *strct);
int is_Union_type(const ir_type *uni);
int is_code_type(const ir_type *tp);
int is_unknown_type(const ir_type *type);
int is_atomic_type(const ir_type *tp);
int is_compound_type(const ir_type *tp);
int is_frame_type(const ir_type *tp);
int is_segment_type(const ir_type *tp);
ir_type *new_type_array(ir_type *element_type, unsigned n_elements);
ir_type *new_type_class(ident *name);
ir_type *new_type_method(size_t n_param, size_t n_res, int is_variadic,
                         unsigned cc_mask,
                         mtp_additional_properties property_mask);
ir_type *new_type_pointer(ir_type *points_to);
ir_type *new_type_primitive(ir_mode *mode);
ir_type *new_type_struct(ident *name);
ir_type *new_type_union(ident *name);
void remove_class_subtype(ir_type *clss, ir_type *subtype);
void remove_class_supertype(ir_type *clss, ir_type *supertype);
void set_method_param_type(ir_type *method, size_t pos, ir_type *tp);
void set_method_res_type(ir_type *method, size_t pos, ir_type *tp);
void set_pointer_points_to_type(ir_type *pointer, ir_type *tp);

ir_type_state get_type_state(const ir_type *tp);
void set_type_state(ir_type *tp, ir_type_state state);
unsigned get_type_size(const ir_type *tp);
unsigned get_type_alignment(const ir_type *tp);

void *get_type_link(const ir_type *tp);
void set_type_size(ir_type *tp, unsigned size);
void set_type_alignment(ir_type *tp, unsigned align);
void set_type_link(ir_type *tp, void *l);
void set_type_dbg_info(ir_type *tp, type_dbg_info *db);

void default_layout_compound_type(ir_type *tp);
